-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 4506 of the CMF schema. Adds the command schedules table.
--

update SCHEMA_VERSION set VERSION=4506;

create table COMMAND_SCHEDULES (
  SPEC_ID bigint not null,
  COMMAND_NAME varchar(255) not null,
  COMMAND_ARGUMENTS longtext,
  CLUSTER_ID bigint,
  SERVICE_ID bigint,
  ROLE_ID bigint,
  HOST_ID bigint,
  START_TIME bigint,
  END_TIME bigint,
  REPEAT_INTERVAL bigint not null,
  REPEAT_INTERVAL_UNIT varchar(255) not null,
  PAUSED bit not null,
  OPTIMISTIC_LOCK_VERSION bigint not null,
  primary key (SPEC_ID)
) engine=InnoDB;

alter table COMMAND_SCHEDULES
  add index FK_COMMAND_SCHEDULE_CLUSTER (CLUSTER_ID),
  add constraint FK_COMMAND_SCHEDULE_CLUSTER
  foreign key (CLUSTER_ID)
  references CLUSTERS (CLUSTER_ID);

alter table COMMAND_SCHEDULES
  add index FK_COMMAND_SCHEDULE_SERVICE (SERVICE_ID),
  add constraint FK_COMMAND_SCHEDULE_SERVICE
  foreign key (SERVICE_ID)
  references SERVICES (SERVICE_ID);

alter table COMMAND_SCHEDULES
  add index FK_COMMAND_SCHEDULE_ROLE (ROLE_ID),
  add constraint FK_COMMAND_SCHEDULE_ROLE
  foreign key (ROLE_ID)
  references ROLES (ROLE_ID);

alter table COMMAND_SCHEDULES
  add index FK_COMMAND_SCHEDULE_HOST (HOST_ID),
  add constraint FK_COMMAND_SCHEDULE_HOST
  foreign key (HOST_ID)
  references HOSTS (HOST_ID);
